import numpy
import scipy.integrate as integrate


def energy(freq, delta):
	return numpy.sqrt(freq ** 2 + delta ** 2)


def gap_integrand_function(xi, temp, delta, mu_star):
	big_e = energy(xi, delta)
	return numpy.tanh((big_e - mu_star) / (2 * temp)) / (2 * big_e)


def gap_integral(temp, delta, mu_star, debye_frequency):
	def integrand(xi):
		# the 2 here is to account for the symmetry in the integration range
		# to cut the integral to zero to omega_debyeh
		return 2 * gap_integrand_function(xi, temp, delta, mu_star)
	return integrate.quad(integrand, 0, debye_frequency)[0]
